various fixes and updates
[distro-setup] / distro-begin
index 75b9b05942ce0ae042d0cd3b188bdfcb2f1a0317..eb51dcbe33fb67d0008357e8bddc203ad6f125f3 100755 (executable)
@@ -55,14 +55,13 @@ if ! $interactive; then
 fi
 source /a/bin/errhandle/err
 
-errcatch-cleanup() {
+err-cleanup() {
   echo 1 >~/.local/distro-begin
 }
 
 source /a/bin/distro-functions/src/package-manager-abstractions
 
 ### setup logging
-exec &> >(sudo tee -a /var/log/distro-begin)
 echo "$0: $(date): starting now)"
 
 
@@ -128,7 +127,7 @@ if encrypted; then
   # but it happened too late in the shutdown process.
   sudo dd of=/etc/systemd/system/keyscripton.service <<'EOF'
 [Unit]
-Description=Turn on automatic decryption of drives on boot
+Description=keyscripton
 # This is triggered by reboot and when keyscriptoff stops.
 
 # tried using graphical.target, but it made my display manager restart before rebooting.
@@ -154,7 +153,7 @@ EOF
 
   sudo dd of=/etc/systemd/system/keyscriptoff.service <<'EOF'
 [Unit]
-Description=Turn off automatic decryption of drives on boot
+Description=keyscriptoff
 
 [Service]
 Type=oneshot
@@ -213,8 +212,13 @@ if [[ $HOSTNAME != $(cat /etc/hostname) ]]; then
   echo $HOSTNAME > /etc/hostname
   hostname -F /etc/hostname
 fi
+# office vpn dhcp adds to /etc/resolv.conf search office.fsf.org which
+# makes that be #1 priority, which makes dnsmasq resolve that for
+# unqualified hosts first, which means we skip the hosts file. Ya, its
+# kinda dumb, but it is what it is. There is a dnsmasq config option to
+# override it too, but this seems simpler.
 sudo sed -i --follow-symlinks -f - /etc/hosts <<EOF
-\$a 127.0.1.1 $HOSTNAME.b8.nz $HOSTNAME
+\$a 127.0.1.1 $HOSTNAME.b8.nz $HOSTNAME.office.fsf.org $HOSTNAME
 /^127\.0\.1\.1/d
 EOF
 
@@ -326,9 +330,9 @@ pi ${p1[@]}
 
 
 ######## fix evbug bug ######
-case $distro in
-  trisquel|ubuntu)
-    # noticed in flidas.
+case $(debian-codename-compat) in
+  xenial)
+    # noticed in flidas. dunno if it affects any others
     #https://bugs.launchpad.net/ubuntu/+source/module-init-tools/+bug/240553
     #https://wiki.debian.org/KernelModuleBlacklisting
     #common advice when searching is to use /etc/modprobe.d/blacklist.conf,
@@ -347,15 +351,15 @@ esac
 
 ###### link files
 # convenient to just do all file linking in one place
-s /a/exe/lnf -T /a/bin /b
-s /a/exe/lnf -T /nocow/t /t
+sudo /a/exe/lnf -T /a/bin /b
+sudo /a/exe/lnf -T /nocow/t /t
 if has_p; then
   lnf -T /p/News ~/News
 fi
-s /a/exe/lnf /q/root/.editor-backups /q/root/.undo-tree-history \
-  /a/opt /a/c/.emacs.d $HOME/mw_vars /k/backup /root
+sudo /a/exe/lnf /q/root/.editor-backups /q/root/.undo-tree-history \
+     /a/opt /a/c/.emacs.d $HOME/mw_vars /k/backup /root
 /a/bin/ds/install-my-scripts # needed for rootsshsync cronjob
-s /a/exe/lnf /a/c/.vim /a/c/.vimrc /a/c/.gvimrc /root
+sudo /a/exe/lnf /a/c/.vim /a/c/.vimrc /a/c/.gvimrc /root
 
 
 
@@ -366,7 +370,7 @@ case $(distro-name) in
   arch)
     # pkgfile is like apt-cache
     pi pkgfile
-    s pkgfile --update
+    sudo pkgfile --update
     ;;
 esac
 
@@ -384,8 +388,8 @@ fi
 
 ##### make extra dirs
 dirs=(/mnt/{1,2,3,4,5,6,7,8,9} /nocow/t)
-s mkdir -p "${dirs[@]}"
-s chown $USER:$USER  "${dirs[@]}"
+sudo mkdir -p "${dirs[@]}"
+sudo chown $USER:$USER  "${dirs[@]}"
 
 ###### setup /i
 if home_network; then
@@ -394,8 +398,8 @@ if home_network; then
 /i/k  /k  none  bind,noauto  0 0
 EOF
   if ! mountpoint /kr; then
-    s mkdir -p /kr
-    s chown $USER:user2 /kr
+    sudo mkdir -p /kr
+    sudo chown $USER:user2 /kr
   fi
   if [[ $HOSTNAME == frodo ]]; then
     tu /etc/fstab <<'EOF'
@@ -406,14 +410,14 @@ EOF
 frodo:/k  /kr  nfs  noauto  0 0
 EOF
   fi
-  s mkdir -p /q /i/{w,k}
+  sudo mkdir -p /q /i/{w,k}
   for dir in /{i,w,k}; do
     if mountpoint $dir; then continue; fi # already mounted
-    s mkdir -p $dir
-    s chown $USER:$USER $dir
+    sudo mkdir -p $dir
+    sudo chown $USER:$USER $dir
   done
   # not needed for all hosts, but rather just keep it uniform
-  s mkdir -p /mnt/iroot
+  sudo mkdir -p /mnt/iroot
   # debian auto mounting of multi-disk encrypted btrfs is busted.  It is
   # in jessie, and in stretch as of 11/26/2016 I have 4 disks in cryptab,
   # based on 3 of those, it creates .device units for /dev/mapper/dev...
@@ -421,7 +425,7 @@ EOF
   # have already been created and exist. todo: create a simple repro
   # for this in a vm and report it upstream.
   pi nfs-common
-  s dd of=/root/imount <<'EOF'
+  sudo dd of=/root/imount <<'EOF'
 #!/bin/bash
 [[ $EUID == 0 ]] || exec sudo -E "${BASH_SOURCE[0]}" "$@"
 set -eE -o pipefail
@@ -437,8 +441,8 @@ for dir in /i /mnt/iroot /k /kr /w; do
     fi
 done
 EOF
-  s chmod +x /root/imount
-  s dd of=/etc/systemd/system/imount.service <<EOF
+  sudo chmod +x /root/imount
+  sudo dd of=/etc/systemd/system/imount.service <<EOF
 [Unit]
 Description=Mount /i and related mountpoints
 Before=syncthing@$USER.service
@@ -468,18 +472,18 @@ if has_btrfs; then
   if ! mountpoint $dir; then
     subvol=/mnt/root/nocow
     if [[ ! -e $subvol ]]; then
-      s btrfs subvolume create $subvol
-      s chown root:1000 $subvol
-      s chattr +C $subvol
+      sudo btrfs subvolume create $subvol
+      sudo chown root:1000 $subvol
+      sudo chattr +C $subvol
     fi
 
     first_root_crypt=$(awk '$2 == "/" {print $1}' /etc/mtab)
     tu /etc/fstab <<EOF
 $first_root_crypt  /nocow  btrfs  noatime,subvol=nocow  0 0
 EOF
-    s mkdir -p $dir
-    s chown $USER:$USER $dir
-    s mount $dir
+    sudo mkdir -p $dir
+    sudo chown $USER:$USER $dir
+    sudo mount $dir
   fi
 else
   sudo mkdir -p $dir
@@ -492,7 +496,7 @@ mail-setup
 #### ubuntu nicety
 if isubuntu; then
   # disable crash report annoying dialogs.
-  s dd of=/etc/default/apport <<<'enabled=0'
+  sudo dd of=/etc/default/apport <<<'enabled=0'
 fi
 
 
@@ -544,31 +548,16 @@ if has_x; then
   esac
 
   ##### setup X autostart
-  if isarch; then
-    # https://wiki.archlinux.org/index.php/Xinitrc
-    for homedir in /home/*; do
-      cp /etc/X11/xinit/xinitrc $homedir/.xinitrc
-      # shellcheck disable=SC2016
-      $sed -ri '/^ *twm\b/,$d' $homedir/.xinitrc
-      tee -a $homedir/.xinitrc <<'EOF'
-/a/bin/desktop-20-autostart.sh
-xsetroot -cursor_name left_ptr
-exec xmonad
-EOF
-    done
-  else
-    # todo, figure this out for arch if we ever try out gnome.
-    # install for multiple display managers in case we use one
-    dir=/etc/gdm3
-    s mkdir -p $dir/PostLogin
-    s command cp /a/bin/distro-setup/desktop-20-autostart.sh $dir/PostLogin/Default
-    s mkdir /etc/lightdm/lightdm.conf.d
-    s dd of=/etc/lightdm/lightdm.conf.d/12-iank.conf <<'EOF'
+  # todo, figure this out for arch if we ever try out gnome.
+  # install for multiple display managers in case we use one
+  dir=/etc/gdm3
+  sudo mkdir -p $dir/PostLogin
+  sudo cp /a/bin/distro-setup/desktop-20-autostart.sh $dir/PostLogin/Default
+  sudo mkdir -p /etc/lightdm/lightdm.conf.d
+  sudo dd of=/etc/lightdm/lightdm.conf.d/12-iank.conf <<'EOF'
 [SeatDefaults]
 session-setup-script=/a/bin/distro-setup/desktop-20-autostart.sh
 EOF
-  fi
-
 fi
 
 ### install and configure wayland
@@ -577,7 +566,7 @@ if has_wayland; then
   # originally used xkbcomp, documented in input-setup.sh, this doesnt
   # work under wayland, but its still useful for creating the config,
   # then modifying the system files.
-  s sed -i.orig '/key *<KPMU> *{/,/}/s/KP_Multiply/underscore/g' /usr/share/X11/xkb/symbols/keypad
+  sudo sed -i.orig '/key *<KPMU> *{/,/}/s/KP_Multiply/underscore/g' /usr/share/X11/xkb/symbols/keypad
 fi
 
 ##### basic graphical packages
@@ -611,4 +600,5 @@ fi
 
 echo 0 >~/.local/distro-begin
 echo "$0: $(date): ending now"
+echo "exiting with status 0"
 exit 0